import React from "react";
import { BrowserRouter as Router, Route, Link } from "react-router-dom";

const App = () => (
  <Router>
    <div>
      <Header />

      <Route exact path="/" component={Homes} />
      <Route path="/about" component={Abouts} />
      <Route path="/films" component={Films} />
      <Route path="/starships" component={Starships} />
      <Route path="/species" component={Species} />
      <Route path="/planets" component={Planets} />
    </div>
  </Router>
);

const Home = () => <h2>Home</h2>;
const About = () => <h2>About</h2>;
const Film = ({ match }) => <h3>Here is {match.params.id}</h3>;
const Starship = ({ match }) => <h3>Here is {match.params.id}</h3>;
const Specie = ({ match }) => <h3>Here is {match.params.id}</h3>;
const Planet = ({ match }) => <h3>Here is {match.params.id}</h3>;

/*
const movies = fetch('https://swapi.co/api/films/')
.then(res => res.json())
.then(res => {
  return res.count;
});
*/

const Homes = ({ match }) => (
  <div>
    <h2>Home</h2>
    <Route path={`${match.path}/:id`} component={Home} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Under construction (see "About").</h3>}
    />
  </div>
);

const Abouts = ({ match }) => (
  <div>
    <h2>About</h2>
    <Route path={`${match.path}/:id`} component={About} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Here is an react app with routing system using Star Wars API (SWAPI).</h3>}
    />
  </div>
);

const Films = ({ match }) => (
  <div>
    <h2>Films</h2>
    <ul>
      <li>
        <Link to={`${match.url}/toto`}>toto</Link>
      </li>
      <li>
        <Link to={`${match.url}/tata`}>tata</Link>
      </li>
    </ul>

    <Route path={`${match.path}/:id`} component={Film} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Please select a films what you whant to see.</h3>}
    />
  </div>
);

const Starships = ({ match }) => (
  <div>
    <h2>Starships</h2>
    <ul>
      <li>
        <Link to={`${match.url}/toto`}>toto</Link>
      </li>
      <li>
        <Link to={`${match.url}/tata`}>tata</Link>
      </li>
    </ul>

    <Route path={`${match.path}/:id`} component={Starship} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Please select a starships what you whant to see.</h3>}
    />
  </div>
);

const Species = ({ match }) => (
  <div>
    <h2>Species</h2>
    <ul>
      <li>
        <Link to={`${match.url}/toto`}>toto</Link>
      </li>
      <li>
        <Link to={`${match.url}/tata`}>tata</Link>
      </li>
    </ul>

    <Route path={`${match.path}/:id`} component={Specie} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Please select a species what you whant to see.</h3>}
    />
  </div>
);

const Planets = ({ match }) => (
  <div>
    <h2>Planets</h2>
    <ul>
      <li>
        <Link to={`${match.url}/toto`}>toto</Link>
      </li>
      <li>
        <Link to={`${match.url}/tata`}>tata</Link>
      </li>
    </ul>

    <Route path={`${match.path}/:id`} component={Planet} />
    <Route
      exact
      path={match.path}
      render={() => <h3>Please select a planets what you whant to see.</h3>}
    />
  </div>
);

const Header = () => (
  <ul>
    <li>
      <Link to="/">Home</Link>
    </li>
    <li>
      <Link to="/about">About</Link>
    </li>
    <li>
      <Link to="/films">Films</Link>
    </li>
    <li>
      <Link to="/starships">Starships</Link>
    </li>
    <li>
      <Link to="/species">Species</Link>
    </li>
    <li>
      <Link to="/planets">Planets</Link>
    </li>
  </ul>
);

export default App;